{===============================================================}
{    Oxygen Plan Library, v1.3  1999-2001 Oxygen Software      }
{---------------------------------------------------------------}
{        Written by Oleg Fyodorov, delphi@oxygensoftware.com    }
{                http://www.oxygensoftware.com                  }
{===============================================================}

unit QRPlan;

interface

  uses Windows, Classes, O2Plan, QuickRpt, Graphics;

{$I O2Plan.inc}

  type

    TQROxygenPlan = class(TQRPrintable)
      private
        FPlan : TOxygenPlan;
      public
        constructor Create(AOwner : TComponent); override;
        procedure Print(OfsX, OfsY : integer); override;
        procedure Paint; override;
      published
        property Plan : TOxygenPlan read FPlan write FPlan;
      end;

  procedure Register;

implementation

{$R QRPlan.res}

constructor TQROxygenPlan.Create(AOwner : TComponent);
begin
  inherited Create(AOwner);
  FPlan := nil;
  Width := 350;
  Height := 200;
end;

procedure TQROxygenPlan.Print(OfsX, OfsY : Integer);
  var mf : TMetafile;
      r : TRect;
{$IFDEF O2_SW}
      s : String;
{$ENDIF}
begin
  if (FPlan <> nil) then begin
    with ParentReport.QRPrinter do begin
      r := Rect(XPos(Size.Left + OfsX), YPos(Size.Top + OfsY), XPos(Size.Left + Size.Width + OfsX), YPos(Size.Top + Size.Height + OfsY));
      mf := nil;
      FPlan.Printing := True;
      try
        mf := FPlan.GetMetafile;
        Canvas.StretchDraw(r,mf);
      finally
        FPlan.Printing := False;
        FPlan.Repaint;
        if (mf <> nil) then mf.Free;
      end;
{$IFDEF O2_SW}
      s := 'Oxygen Plan Library is not registered';
      Canvas.Font.Name := 'Arial';
      Canvas.Font.Size := 20;
      Canvas.Font.Color := clSilver;
      Canvas.Brush.Style := bsClear;
      Canvas.TextOut((PaperWidthValue - Canvas.TextWidth(s)) div 2, PaperLengthValue div 2,s);
{$ENDIF}
    end;
  end;
  inherited Print(OfsX,OfsY);
end;

procedure TQROxygenPlan.Paint;
begin
  if (FPlan <> nil) then with FPlan do begin
    Printing := True;
    try
      PaintToCanvas(Self.Canvas, Self.Width, Self.Height);
    finally
      Printing := False;
      Repaint;
    end;
  end;
  inherited Paint;
end;

procedure Register;
begin
  RegisterComponents('QReport',[TQROxygenPlan]);
end;

end.
